import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Persistence;

public final class FirstPersistIsSlow {

	public static void main(String[] args) {
		EntityManagerFactory emf = Persistence.createEntityManagerFactory("objectdb:$objectdb/db/test.tmp;drop");
		EntityManager em = emf.createEntityManager();

		long startT;
		long startP;
		long endP;

		// First transaction with persist of MyEntity:
		startT = ct();
		em.getTransaction().begin();
		startP = ct();
		em.persist(new MyEntity());
		endP = ct();
		em.getTransaction().commit();
		System.out.println("First transaction with persist of MyEntity \t Transaction: " + (ct() - startT)
				+ " \t Persist: " + (endP - startP));

		System.out.println();

		// Persist first entity:
		startT = ct();
		em.getTransaction().begin();
		startP = ct();
		em.persist(new FirstEntity());
		endP = ct();
		em.getTransaction().commit();
		System.out.println(
				"First persist of FirstEntity \t Transaction: " + (ct() - startT) + " \t Persist: " + (endP - startP));

		// Persist second entity:
		startT = ct();
		em.getTransaction().begin();
		startP = ct();
		em.persist(new FirstEntity());
		endP = ct();
		em.getTransaction().commit();
		System.out.println(
				"Second persist of FirstEntity \t Transaction: " + (ct() - startT) + " \t Persist: " + (endP - startP));

		System.out.println();

		// Persist first entityTwo:
		startT = ct();
		em.getTransaction().begin();
		startP = ct();
		em.persist(new SecondEntity());
		endP = ct();
		em.getTransaction().commit();
		System.out.println("First persist of SecondEntity \t Transaction: " + (ct() - startT) + "  \t Persist: "
				+ (endP - startP));

		// Persist second entity:
		startT = ct();
		em.getTransaction().begin();
		startP = ct();
		em.persist(new SecondEntity());
		endP = ct();
		em.getTransaction().commit();
		System.out.println("Second persist of SecondEntity \t Transaction: " + (ct() - startT) + " \t Persist: "
				+ (endP - startP));

		em.close();
		emf.close();
	}

	/**
	 * Get currentTimeMillis
	 * 
	 * @return currentTimeMillis
	 */
	private static long ct() {
		return System.currentTimeMillis();
	}

	@Entity
	public static class MyEntity {
		@Basic
		Integer value;
	}

	@Entity
	public static class FirstEntity {
		@Basic
		Integer value;

		@OneToOne(cascade = CascadeType.PERSIST)
		FirstEntityChild child = new FirstEntityChild();
	}

	@Entity
	public static class FirstEntityChild {
		@Basic
		Integer value = new Integer(0);
	}

	@Entity
	public static class SecondEntity {
		@OneToMany(cascade = CascadeType.PERSIST)
		List<ChildA> listA = new ArrayList<ChildA>();
		@OneToMany(cascade = CascadeType.PERSIST)
		Set<ChildB> listB = new HashSet<ChildB>();
		@OneToMany(cascade = CascadeType.PERSIST)
		Collection<ChildC> listC = new ArrayList<ChildC>();
		@ManyToOne(cascade = CascadeType.PERSIST)
		ChildD childD = new ChildD();

		public SecondEntity() {
			listA.add(new ChildA());
			listB.add(new ChildB());
			listC.add(new ChildC());
		}
	}

	@Entity
	public static class ChildA {
		@OneToMany(cascade = CascadeType.PERSIST)
		List<ChildA2> listA2 = new ArrayList<ChildA2>();

		public ChildA() {
			listA2.add(new ChildA2());
		}
	}

	@Entity
	public static class ChildA2 {
		@Basic
		Boolean value = new Boolean(true);
	}

	@Entity
	public static class ChildB {
		@OneToMany(cascade = CascadeType.PERSIST)
		List<ChildB2> listB2 = new ArrayList<ChildB2>();

		public ChildB() {
			listB2.add(new ChildB2());
		}
	}

	@Entity
	public static class ChildB2 {
		@Basic
		String value = new String();
	}

	@Entity
	public static class ChildC {
		@OneToMany(cascade = CascadeType.PERSIST)
		List<ChildC2> listC2 = new ArrayList<ChildC2>();

		public ChildC() {
			listC2.add(new ChildC2());
		}
	}

	@Entity
	public static class ChildC2 {
		@Basic
		Double value;
	}

	@Entity
	public static class ChildD {
		@OneToMany(cascade = CascadeType.PERSIST)
		List<ChildD2> listD2 = new ArrayList<ChildD2>();

		public ChildD() {
			listD2.add(new ChildD2());
		}
	}

	@Entity
	public static class ChildD2 {
		@Basic
		Date value;
	}

}